'''
Created on 27. 6. 2015

@author: fdobrovolny

API ke komunikaci se serverem
'''

import requests

class Tresure():
    def __init__(self, pos, val):
        self.pos = pos
        self.val = val
    def isThere(self, text):
        return text[self.pos[0]][self.pos[1]*2] + text[self.pos[0]][self.pos[1]*2+1] == str(self)
    def __str__(self):
        if self.val < 10:
            return "0" + str(self.val)
        return str(self.val)

class User():
    def __init__(self, base):
        self.pos = None
        self.carry = None
        self.isCarrying = None
        self.inBase = None
        self.base = None

    def parse_moves(self, text):
        text = text.split(" ")
        self.pos = (int(text[0])-1, int(text[1])-1)
        self.carry = int(text[2])
        self.isCarrying = int(text[2]) > 0
        self.inBase = int(text[3])

class Game():
    def __init__(self, id, turns, url):
        self.id = id
        self.turns = turns # tahy do konce
        self.notEnd = True
        self.plan = [[ "" for y in range(10) ] for i in range(10)]
        self.types = { ".." : "..", "XX" : "##" , "--" : "EN", "++" : "WE"}
        self.base = None # souradnice nasi zakladny
        self.enBase = None # souradnice cizi zakladny
        self.tresures = [] # list souradnic pokladu
        self.walls = [] # list souradnic zdi
        self.player = None # objekt hrac
        self.enemy = None # objekt nepritel
        self.moves = ["N", "D", "P", "L"] # naprosta zbytecnost
        self.url = url # adresa
        self.score = None


    def parse_game(self, text):
        # sparsuje herni plan
        for x in range(10):
            for y in range(10):
                field = text[x][y*2] + text[x][y*2+1]
                if field in self.types:
                    self.plan[x][y] = self.types[field]
                    if self.types[field] == "WE":
                        self.base = (x, y)
                    elif self.types[field] == "EN":
                        self.enBase = (x, y)
                    elif self.types[field] == "##":
                        self.walls.append((x, y))
                else:
                    tre = Tresure((x, y), int(field))
                    self.tresures.append(tre)
                    self.plan[x][y] = tre
        self.player = User(self.base)
        self.player.parse_moves(text[10])
        if self.enBase != None:
            self.enemy = User(self.enBase)
            self.enemy.parse_moves(text[11])


    def print_game(self):
        # vypise herni plan
        for x in self.plan:
            for y in x:
                print(y, end="")
            print()


    def move(self, move):
        # udela tah
        if move == None:
            return
        r = requests.get(self.url + '/tah', params={"id" : self.id, "pohyb" : move})
        text = r.text.splitlines()
        if text[0][0] == "K":
            text = text[0][text[0].find(": ")+1:]
            self.notEnd = False
            self.score = text
            self.turns = 0
            return "END", text
        self.turns = int(text[1])
        text = text[2:]
        for i in self.tresures:
            if not i.isThere(text):
                self.plan[i.pos[0]][i.pos[1]] = ".."
                self.tresures.remove(i)

        self.player.parse_moves(text[10])
        if not self.enemy is None: self.enemy.parse_moves(text[11])

def start_game(url):
    # vytvori herni objekt
    r = requests.get(url + '/start')
    text = r.text
    text = text.splitlines()
    game = Game(int(text[0]), int(text[1]), url)
    game.parse_game(text[2:])
    return game
